image: node:14-alpine

stages: # List of stages for jobs, and their order of execution
  - test
  # - build
  # - deploy

cache:
  paths:
    - node_modules/

workflow:
  rules:
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "develop"
    - if: $CI_MERGE_REQUEST_TARGET_BRANCH_NAME == "main"

default:
  before_script:
    - apk add --no-cache git
    # See next line: 25269024 is gitLab's project ID of charger-app (https://gitlab.com/go-e/linux-platform/app/charger-app)
    - echo "@goe:registry=https://gitlab.com/api/v4/projects/25269024/packages/npm/" > .npmrc
    - echo "//gitlab.com/api/v4/projects/25269024/packages/npm/:_authToken=${CI_JOB_TOKEN}" >> .npmrc
    # bash needs to be added to launch .sh scripts at postinstall stage
    - apk update && apk add bash
    - yarn

unit-test-job: # This job runs in the test stage.
  stage: test # It only starts when the job in the build stage completes successfully.
  script:
    - yarn test

lint-test-job: # This job also runs in the test stage.
  stage: test # It can run at the same time as unit-test-job (in parallel).
  script:
    - yarn lint

typescript-test-job: # This job also runs in the test stage.
  stage: test # It can run at the same time as unit-test-job (in parallel).
  script:
    - yarn ts
# build-job: # This job runs in the build stage.
#   stage: build
#   script:
#     - npm run build

# deploy-job: # This job runs in the deploy stage.
#   stage: deploy # It only runs when *both* jobs in the test stage complete successfully.
#   script:
#     - echo "Deploying application..."
#     - echo "Application successfully deployed."
